#pragma once
#include <string>
#include <xmlrpc-c/client_simple.hpp>
#include <chrono>

namespace spin
{
    class IXmlRpcClient
    {
    public:
        virtual ~IXmlRpcClient() = default;
        virtual void setHost(const std::string &host) = 0;
        virtual std::string host() const = 0;
        virtual void execute(const std::string &method, xmlrpc_c::value *result) = 0;
        virtual void execute(const std::string &method, const xmlrpc_c::paramList &params, xmlrpc_c::value *result) = 0;
        virtual void execute(const std::string &method, const xmlrpc_c::paramList &params, xmlrpc_c::value *result, const std::chrono::milliseconds timeout) = 0;
    };

} // namespace spin
